#include <conf.h>

#include <exec/types.h>

#include <sys/malloc.h>

#include <api/amiga_api.h>
#include <api/allocdatabuffer.h>

BOOL doAllocDataBuffer (struct DataBuffer *DB, int size)
{
  if (DB->db_Addr)
    bsd_free (DB->db_Addr, M_TEMP);

  if ((DB->db_Addr = bsd_malloc (size, M_TEMP, M_WAITOK)) == NULL)
    {
      DB->db_Size = 0;
      return FALSE;
    }
  DB->db_Size = size;
  return TRUE;
}

VOID freeDataBuffer (struct DataBuffer * DB)
{
  if (DB->db_Addr)
    bsd_free (DB->db_Addr, M_TEMP);
  DB->db_Size = 0;
  DB->db_Addr = NULL;
}

BOOL allocDataBuffer (struct DataBuffer *DB, int size)
{
  if (DB->db_Size < size)
    return doAllocDataBuffer (DB, size);
  else
    return TRUE;
}
